// ============================================================================
//
// Copyright (c) 2010, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ===================================================================



#ifndef BOARD_H_
#define BOARD_H_

#include "common.h"
#include "cell.h"

// class of the game board
// ----------------------------------------------------------------------------
class Board
{
private:

    int x_pos; // current position of the seed
    int y_pos;

    // color  parameters pf the seed
    GLfloat seed_ambient_and_diff[3];
    GLfloat seed_shininess[1];
    GLfloat seed_specular[4];

    GLfloat shadow_color[3];

    int x_size; // board size
    int y_size;

    Cell*** cells; // board cells

public:

    // proceed to the board initialization
    Board(int x, int y);
    // (initializes the dynamic array and the cells)

    // reinit
    void init(void);

    // destructor, delete the board cells
    ~Board(void);

    // Create a new seed
    void create_random_seed(void);

    // Get the seed position
    void get_seed_pos(int &seed_x, int &seed_y);

    // Compare given position with the seed's position
    bool is_on_seed_cell(int x, int y);
    // (returns true of both position matche)

    // display the board
    void proceed_display(void);

    int get_x_size();
    int get_y_size();

    Cell* get_cell (int x, int y);


};

#endif /* BOARD_H_ */
