// ============================================================================
//
// Copyright (c) 2010, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ===================================================================



#include "body_part.h"

extern GLfloat light_0_shadow[4][4];

// class of a element of the body
// ----------------------------------------------------------------------------

// constructor : fix initial position
Body_Part::Body_Part(void)
{
    mat_shininess[0] = 80.0;
    set_color_array(mat_specular, 0.8, 0.9, 1.0, 1.0);
    set_color_array(mat_ambient_and_diff, 0.4, 0.5, 0.8);

    set_color_array(shadow_color, 0.2, 0.2, 0.3);

    // create display list
    display_list = glGenLists(1);
    glNewList(display_list, GL_COMPILE);
        this->proceed_display();
    glEndList();
}

Body_Part::~Body_Part()
{
}

// fix original position of the body part
void Body_Part::set_origin(int x, int y, int no)
{
    this->set_pos(x, y);
    this->number = no;
}

// Display the body part
void Body_Part::proceed_display(void)
{

    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_ambient_and_diff);
    glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, mat_shininess);
    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);

    glTranslatef(5.0, 5.0, 0.0);

    // draw shadow
    glDisable(GL_LIGHTING);
    glColor3fv(shadow_color);

    glPushMatrix();
        glTranslatef(0.0, 0.0, 0.1);
        glMultMatrixf((GLfloat *) light_0_shadow);
        glTranslatef(0.0, 0.0, 5.0);
        glutSolidSphere(6.0, 20.0, 10.0);
    glPopMatrix();

    glEnable(GL_LIGHTING);

    // draw the body part
    glTranslatef(0.0, 0.0, 5.0);
    glutSolidSphere(6.0, 20.0, 20.0);
}

