// ============================================================================
//
// Copyright (c) 2010, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ===================================================================



#ifndef CAMERA_H_
#define CAMERA_H_

#include "common.h"
#include "board.h"

// class of the camera
// ----------------------------------------------------------------------------
class Camera
{
private:

    GLfloat position[3]; // the position
    GLfloat direction[3]; // the target direction
    GLfloat up_vector[3]; // the vector ...

    float spin; // ...

    bool do_rotation; // whether the camera should rotate or not

    float speed_coeff_cam;

    // to set the movement speed coeff
    void save_value_coeff(float coeff);

public:

    // default constructor
    Camera(void);

    // reinitialize the camera
    void init(void);

    // position the camera
    void proceed_position(void);

    // start or stop the camera rotation
    void start_stop_rotation(void);

    // define the camera
    void reshape(GLsizei width, GLsizei height);
};

#endif
