// ============================================================================
//
// Copyright (c) 2010, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ===================================================================



#ifndef CELL_H_
#define CELL_H_

#include "common.h"
#include "display_object.h"

// Class of a cell of the game board
class Cell : public Display_Object
{

private:

    bool free; // whether the cell is free of not at the current moment in time

    // color parameters
    GLfloat ground_shininess[1];
    GLfloat ground_specular[4];
    GLfloat ground_ambient_and_diff[3];

public:

    // default constructor
    Cell(void);

    // destructor
    virtual ~Cell(void);

    // constructor taking as argument the position of the cell
    Cell(int x, int y);

    // --------------------------------------------------------------
    bool is_free(void); // returns true of the cell is free

    void set_free(void); // mark the cell as free

    void set_used(void); // mark the cell as busy
    // --------------------------------------------------------------

    // display the cell
    void proceed_display(void);

    direction_tp get_cell_direction(Cell* cell);

    std::vector<Cell*>* get_neighbours();

};

#endif
