// ============================================================================
//
// Copyright (c) 2010, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ===================================================================



// common stuff


#ifndef COMMON_H
#define COMMON_H

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include <math.h>
#include <vector>
#include <list>

#ifdef _WIN32
#include <windows.h>
#else
#include <curses.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#ifndef bool
#define bool int
#define false 0
#define true 1
#endif

#define offset_range 100

#define board_size 18

#define x_res 800
#define y_res 600

#define my_pi 3.1415927

#define display_each_second 30
#define worm_initial_offset_speed 15

typedef enum {up, left, down, right} direction_tp ;

typedef struct action_temp* action_ptt;

typedef struct action_temp
{
  action_ptt next;
  direction_tp dir;
} action_tp;


void set_color_array (GLfloat*, GLfloat, GLfloat, GLfloat);

void set_color_array (GLfloat* tab, GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);

void compute_normal_vector (GLfloat* point_1 , GLfloat* point_2 , GLfloat* point_3 , GLfloat norm[3]);

void draw_square (void);

void draw_little_square (void);

unsigned long get_time(void);

void shadow_matrix_calc(GLfloat shadow_mat[4][4], GLfloat ground_plane[4], GLfloat light_pos[4]);

void find_plane(GLfloat plane[4], GLfloat v0[3], GLfloat v1[3], GLfloat v2[3]);

#endif
