// ============================================================================
//
// Copyright (c) 2010, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ===================================================================



#ifndef DISPLAY_OBJECT_H_
#define DISPLAY_OBJECT_H_


#include "common.h"



// Class of a object being anyhow displayed in the world
class Display_Object
{

protected:

    direction_tp direction; // each cell has a direction associated to it. This is how the worm moves.
    // The head sets the direction and the body elements follow

    // inherited color parameters
    GLfloat mat_shininess[1];
    GLfloat mat_specular[4];
    GLfloat mat_ambient_and_diff[3];

    int x_pos; // cell position on the board
    int y_pos;

    GLuint display_list; //

public:

    // default constructor
    Display_Object(void);

    // destructor
    virtual ~Display_Object(void);

    // constructor taking as argument the position of the display object
    Display_Object(int x, int y);

    void set_pos(int x, int y); // fix the object position

    void get_pos(int &x, int &y); // get the object potition

    direction_tp get_direction(void); // get the direction

    void set_direction(direction_tp dir); // set the direction

    // display the object
    virtual void proceed_display(void) = 0;

};



#endif /* DISPLAY_OBJECT_H_ */
