// ============================================================================
//
// Copyright (c) 2010, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ===================================================================

#include "head.h"

extern GLfloat light_0_shadow[4][4];

// class of the head of the worm
// ----------------------------------------------------------------------------

// default constructor
Head::Head(void)
{
    mat_shininess[0] = 30.0;
    set_color_array(mat_specular, 0.8, 0.9, 1.0, 1.0);
    set_color_array(mat_ambient_and_diff, 0.2, 0.4, 0.9);

    set_color_array(shadow_color, 0.2, 0.2, 0.3);

    // create display list
    display_list = glGenLists(1);
    glNewList(display_list, GL_COMPILE);
        this->proceed_display();
    glEndList();
}

Head::~Head()
{
}

// display the head
void Head::proceed_display(void) {
    //glPushMatrix () ;

    /*glTranslatef (10.0 * this->x_pos,
     10.0 * this->y_pos,
     0.0) ;

     switch (this->get_direction())
     {
     case droite : glTranslatef ( (float) offset / (float) (offset_range / 10), 0.0, 0.0);
     break;
     case haut   : glTranslatef (0.0, (float) offset / (float) (offset_range / 10), 0.0);
     break;
     case gauche : glTranslatef ( (float)-offset / (float) (offset_range / 10), 0.0, 0.0);
     break;
     case bas    : glTranslatef (0.0, (float)-offset / (float) (offset_range / 10), 0.0);
     break;
     }
     */
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_ambient_and_diff);
    glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, mat_shininess);
    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);

    glTranslatef(5.0, 5.0, 0.0);

    // draw shadow
    glDisable(GL_LIGHTING);
    glColor3fv(shadow_color);

    glPushMatrix();
        glTranslatef(0.0, 0.0, 0.1);
        glMultMatrixf((GLfloat *) light_0_shadow);
        glTranslatef(0.0, 0.0, 5.0);
        glutSolidSphere(6.0, 20.0, 10.0);
    glPopMatrix();

    glEnable(GL_LIGHTING);

    // draw the head sphere
    glTranslatef(0.0, 0.0, 5.0);
    glutSolidSphere(6.0, 20.0, 20.0);

    //glPopMatrix () ;
}
