// ============================================================================
//
// Copyright (c) 2010, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ===================================================================




#include "spot.h"

extern Board* board;

// spot class
// ----------------------------------------------------------------------------

// default constructor
Spot::Spot(void)
{
    set_color_array(light_specular, 1.0, 1.0, 1.0, 1.0);
    set_color_array(light_ambient, 0.4, 0.4, 0.4, 1.0);
    set_color_array(light_diffuse, 1.0, 1.0, 1.0, 1.0);

    light_cutoff = 20.0;
    light_exponent = 30.0;

    set_color_array(light_position, 0.0, 0.0, 4.0 * board->get_x_size());
    set_color_array(light_direction, 0.0, 0.0, -1.0);

    spin = 0.0;
}

// initialize light parans
void Spot::init_spot(void)
{
    glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
    glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
    glLightf(GL_LIGHT0, GL_SPOT_CUTOFF, light_cutoff);
    glLightf(GL_LIGHT0, GL_SPOT_EXPONENT, light_exponent);
    glLightf(GL_LIGHT0, GL_LINEAR_ATTENUATION, 5.0);
}

// get spot position
void Spot::get_light_position(GLfloat* light_pos)
{
    light_pos[0] = light_position[0];
    light_pos[1] = light_position[1];
    light_pos[2] = light_position[2];
}

// position the spot
void Spot::proceed_position(void)
{
    glLightfv(GL_LIGHT0, GL_POSITION, light_position);
    glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, light_direction);
}
