// ============================================================================
//
// Copyright (c) 2010, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ===================================================================



#ifndef SPOT_H_
#define SPOT_H_

#include "common.h"
#include "board.h"

// class of the spot
// ----------------------------------------------------------------------------
class Spot
{
private:

    // spot parameters
    GLfloat light_specular[4];
    GLfloat light_ambient[4];
    GLfloat light_diffuse[4];

    GLfloat light_cutoff;
    GLfloat light_exponent;

    GLfloat light_position[3];
    GLfloat light_direction[3];

    int spin;

public:

    // default constructor
    Spot(void);

    // initialize light parameters
    void init_spot(void);

    // position the spot
    void proceed_position(void);

    // get the spot position
    void get_light_position(GLfloat* light_pos);

};

#endif /* SPOT_H_ */
