// ============================================================================
//
// Copyright (c) 2010, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ===================================================================



#ifndef WORM_H_
#define WORM_H_

#include "common.h"

#include "board.h"
#include "head.h"
#include "body_part.h"
#include "engine.h"

// class of the worm
// ----------------------------------------------------------------------------

class Worm
{

private:

    int body_part_number; // current number of elements (head exluded)

    int offset; // the current offset related to the begining of the cells
    // (When exceeds the max offset, the worm has moved to the next
    // cell)

    // constituents
    Head head; // the head
    Body_Part* body; // the body parts

    float speed_coeff_worm;

    int init_x, init_y;

    direction_tp init_dir;

    void handle_head_movement(int x_next_position, int y_next_position,
            int & quit, int head_x, int head_y);

public:

    // Fix the worm speed increment FIXME rename me
    void fixe_coeff(float coeff);

    // constructor : fix initial position of the head
    Worm(int x, int y, direction_tp dir);

    // initialize the worm
    void init(void);

    // destructor (destroys dynamic elements)
    ~Worm();

    void move(void); // Make the worm move ahead one unit of distance

    // add a body part to the worm
    void add_part(int head_x, int head_y);

    bool move_cell(void);// register new directions
    // (returns false in case of crahs or our of bounds)

    // aks the worm for the new direction
    void set_direction(direction_tp dir);

    // get the position of the worm's head
    void get_head_pos(int &head_x, int &head_y);

    int get_offset(void); // used to know the current offset

    // used to get the number of body parts
    int get_body_part_number(void);

    // used to know where to pooint the camera
    void get_pointing_pos(float &x, float &y);
    // (deprecated)

    // Get thr direction of the head
    direction_tp get_direction(void);

    void proceed_display(void); // display the worm
};

#endif
